package org.freecompany.brimstone.main;

import org.freecompany.brimstone.core.URNConnection;
import org.freecompany.brimstone.core.URNConnection.ListenerAdapter;
import java.io.PrintStream;
import java.net.URL;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

public class DefaultListener extends ListenerAdapter {

	protected final Map< URL, Formatter> urls = new HashMap< URL, Formatter>();
	protected final PrintStream stream;

	public DefaultListener() { this( null); }
	public DefaultListener( final PrintStream stream) { this.stream = stream; }

	@Override
	public synchronized void foundLocation( final URNConnection connection, final URL url) {
		final Formatter formatter = new Formatter( connection.getURL().toString().replaceAll( ".*/", ""), stream);
		urls.put( connection.getURL(), formatter);
		formatter.setTotal( connection.getContentLength());
	}

	@Override
	public synchronized void transferred( final URNConnection connection, final int bytes) {
		if ( urls.containsKey( connection.getURL())) urls.get( connection.getURL()).read( bytes);
	}

	@Override
	public synchronized void complete( final URNConnection connection) {
		if ( urls.containsKey( connection.getURL())) {
			urls.get( connection.getURL()).finish();
			urls.remove( connection.getURL());
		}
	}
}
