package org.freecompany.brimstone.main;

import java.io.PrintWriter;
import java.io.StringWriter;
import java.text.MessageFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.logging.Formatter;
import java.util.logging.LogRecord;

public class LogFormatter extends Formatter {

	protected final SimpleDateFormat date = new SimpleDateFormat( "MMM d, yyyy hh:mm:ss a");

	public String format( final LogRecord record) {
		final StringBuilder builder = new StringBuilder( "(").append( record.getLevel()).append( ") ");
		builder.append( date.format( new Date( record.getMillis())));
		builder.append( ": [").append( record.getSourceClassName().replaceAll( ".*[.]", ""));
		builder.append( ".").append( record.getSourceMethodName());
		builder.append( "] ").append( MessageFormat.format( record.getMessage(), record.getParameters())).append( "\n");

		final Throwable thrown = record.getThrown();
		if ( thrown != null) {
			final StringWriter writer = new StringWriter();
			thrown.printStackTrace( new PrintWriter( writer));
			builder.append( writer.toString()).append( "\n");
		}
		return builder.toString();
	}	
}
